#!/usr/bin/env ruby

tm_status = `tmutil status`

running = tm_status.match(/Running = (\d)/)[1]
phase = tm_status.match(/BackupPhase = (.+);/)[1] if running == '1'

if running == '1' && phase == 'Copying'
    perc_str = tm_status.match(/Percent = "?([\d.]+)"?/)
    perc = perc_str[1].to_f.round(4)*100 if perc_str
    # remain = tm_status.match(/TimeRemaining = ([\d]+)/)[1]
    bytes = tm_status.match(/bytes = ([\d]+)/)[1].to_i/1000/1000
    totalBytes = tm_status.match(/totalBytes = ([\d]+)/)[1].to_i/1000/1000
    files = tm_status.match(/files = ([\d]+)/)[1].to_i
    totalFiles = tm_status.match(/totalFiles = ([\d]+)/)[1].to_i
    puts "#{phase}: #{perc}% #{bytes}MB/#{totalBytes}MB #{files}/#{totalFiles}"
elsif phase && phase != 'Copying'
    puts "#{phase}..."
else
    last = `date -j -f "%a %b %d %T %Z %Y" "$(/usr/libexec/PlistBuddy -c "Print Destinations:0:SnapshotDates" /Library/Preferences/com.apple.TimeMachine.plist | tail -n 2 | head -n 1 | awk '{$1=$1};1')" "+%Y-%m-%d %H:%M"`
    puts last.split('/').last
end
